Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -699,5 +1286,26 @@
                             r_tgt_update = false; 
                             r_vci_tgt_fsm = TGT_REQ_ICACHE;
+                            uint32_t tgt_num_cpu   = p_vci_tgt.pktid.read();
+                            uint32_t tgt_num_cache = get_num_icache(tgt_iaddr,tgt_num_cpu);
+                            r_tgt_num_cache = tgt_num_cache;
+                            
+                            PRINTF("    * <TGT> REQ_ICACHE\n");
+                            PRINTF("    * <TGT> num_cache        : %d\n",tgt_num_cache);
+
                             m_cpt_cc_inval_icache++ ;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                            {
+                                log_transaction_file_tgt
+                                    << "[" << m_cpt_total_cycles << "] "
+                                    << "INVAL INS  "
+                                    << std::hex
+                                    << " L " << std::setw(10) << (uint64_t)tgt_addr
+                                    << std::dec
+                                    << " - " << tgt_num_cache
+                                    << std::endl;
+                            }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
                         } 
                         else if ( (cell == 8) or (cell==12) )    // update data or instruction
@@ -713,4 +1321,23 @@
                                 m_cpt_cc_update_dcache++;
                                 r_tgt_update_data = true;
+
+                                uint32_t tgt_num_cache = get_num_dcache(tgt_daddr);
+                                r_tgt_num_cache = tgt_num_cache;
+                                
+                                PRINTF("    * <TGT> UPDT_WORD DATA\n");
+                                PRINTF("    * <TGT> num_cache        : %d\n",tgt_num_cache);
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_tgt
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "UPT DATA   "
+                                        << std::hex
+                                        << " L " << std::setw(10) << (uint64_t)tgt_addr
+                                        << std::dec
+                                        << " - " << tgt_num_cache
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                             }
                             else
@@ -718,4 +1345,24 @@
                                 m_cpt_cc_update_icache++;
                                 r_tgt_update_data = false;
+
+                                uint32_t tgt_num_cpu   = p_vci_tgt.pktid.read();
+                                uint32_t tgt_num_cache = get_num_icache(tgt_iaddr,tgt_num_cpu);
+                                r_tgt_num_cache = tgt_num_cache;
+                                
+                                PRINTF("    * <TGT> UPDT_WORD INSTRUCTION\n");
+                                PRINTF("    * <TGT> num_cache        : %d\n",tgt_num_cache);
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_tgt
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "UPT INS    "
+                                        << std::hex
+                                        << " L " << std::setw(10) << (uint64_t)tgt_addr
+                                        << std::dec
+                                        << " - " << tgt_num_cache
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                             }
                             r_tgt_update = true; 
@@ -724,4 +1371,9 @@
 
                     } // end if address
+                    
+                    r_tgt_iaddr      = tgt_iaddr;
+                    r_tgt_daddr      = tgt_daddr;
+                    PRINTF("    * <TGT> address (after)  : i %llx, d %llx\n",(uint64_t)tgt_iaddr,(uint64_t)tgt_daddr);
+
                 } // end if cmdval
                 break;
@@ -739,5 +1391,5 @@
                     r_tgt_word = p_vci_tgt.wdata.read(); // the first modified word index
 #ifdef COHERENCE_DEBUG
-                    std::cout << "PROC " << m_srcid_rw << " update, line : " << std::hex << r_tgt_addr.read() << " word : " << p_vci_tgt.wdata.read() << std::dec << std::endl;
+                    std::cout << "PROC " << m_srcid_rw << " update, line : " << std::hex << r_tgt_daddr.read() << " word : " << p_vci_tgt.wdata.read() << std::dec << std::endl;
 #endif
                     r_vci_tgt_fsm = TGT_UPDT_DATA;
@@ -789,9 +1441,27 @@
 
             case TGT_REQ_BROADCAST:
-                if ( not r_tgt_icache_req.read() and not r_tgt_dcache_req.read() ) 
-                {
-                    r_vci_tgt_fsm = TGT_RSP_BROADCAST; 
-                    r_tgt_icache_req = true;
-                    r_tgt_dcache_req = true;
+                {
+                    bool tgt_icache_req;
+
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                    tgt_icache_req = r_tgt_icache_req[r_tgt_num_cache].read();
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+                    tgt_icache_req = false;
+                    for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                        tgt_icache_req |= r_tgt_icache_req[num_cache].read();
+#endif
+                    if (not tgt_icache_req and not r_tgt_dcache_req[r_tgt_num_cache].read()) 
+                    {
+                        r_vci_tgt_fsm = TGT_RSP_BROADCAST; 
+
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                        r_tgt_icache_req[r_tgt_num_cache] = true;
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+                        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                        r_tgt_icache_req[      num_cache] = true;
+#endif
+
+                        r_tgt_dcache_req[r_tgt_num_cache] = true;
+                    }
                 }
                 break;
@@ -799,8 +1469,9 @@
             case TGT_REQ_ICACHE:
                 {
-                    if ( not r_tgt_icache_req.read() ) 
+                    // Request treated by the icache
+                    if ( not r_tgt_icache_req[r_tgt_num_cache].read() ) 
                     {
                         r_vci_tgt_fsm = TGT_RSP_ICACHE; 
-                        r_tgt_icache_req = true;
+                        r_tgt_icache_req[r_tgt_num_cache] = true;
                     }
                     break;
@@ -808,63 +1479,252 @@
 
             case TGT_REQ_DCACHE:
-                if ( not r_tgt_dcache_req.read() ) 
-                {
-                    r_vci_tgt_fsm = TGT_RSP_DCACHE; 
-                    r_tgt_dcache_req = true;
-                }
-                break;
-
+                {
+                    // Request treated by the dcache
+
+                    if ( not r_tgt_dcache_req[r_tgt_num_cache].read() ) 
+                    {
+                        r_vci_tgt_fsm = TGT_RSP_DCACHE; 
+                        r_tgt_dcache_req[r_tgt_num_cache] = true;
+                    }
+                    break;
+                }
             case TGT_RSP_BROADCAST:
-                if ( not r_tgt_icache_req.read() and not r_tgt_dcache_req.read() ) 
-                {
-                    // one response
-                    if ( not r_tgt_icache_rsp or not r_tgt_dcache_rsp )
+                {
+                    PRINTF("      * <TGT> dcache[%d] : %d - %d\n",(uint32_t)r_tgt_num_cache, (uint32_t)r_tgt_dcache_req[r_tgt_num_cache].read(),(uint32_t)r_tgt_dcache_rsp[r_tgt_num_cache].read());
+                    for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                        PRINTF("      * <TGT> icache[%d] : %d - %d\n",(uint32_t)num_cache, (uint32_t)r_tgt_icache_req[num_cache].read(),(uint32_t)r_tgt_icache_rsp[num_cache].read());
+
+                    bool tgt_icache_req;
+                    
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                    tgt_icache_req = r_tgt_icache_req[r_tgt_num_cache].read();
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+                    tgt_icache_req = false;
+                    for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                        tgt_icache_req |= r_tgt_icache_req[num_cache].read();
+#endif
+                    if (not tgt_icache_req and not r_tgt_dcache_req[r_tgt_num_cache].read()) 
                     {
-                        if ( p_vci_tgt.rspack.read() )
+                        bool     tgt_icache_rsp;
+                        uint32_t tgt_icache_rsp_num_cache;
+                        
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                        tgt_icache_rsp_num_cache = r_tgt_num_cache;
+                        tgt_icache_rsp = r_tgt_icache_rsp[r_tgt_num_cache].read();
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+                        tgt_icache_rsp_num_cache = 0;
+                        for (;tgt_icache_rsp_num_cache<m_nb_icache; ++tgt_icache_rsp_num_cache)
                         {
-                            r_vci_tgt_fsm = TGT_IDLE; 
-                            r_tgt_icache_rsp = false;
-                            r_tgt_dcache_rsp = false;
+                            PRINTF("      * <TGT> icache[%d] : %d\n",(uint32_t)tgt_icache_rsp_num_cache, (uint32_t)r_tgt_icache_rsp[tgt_icache_rsp_num_cache].read());
+                            
+                            if (r_tgt_icache_rsp[tgt_icache_rsp_num_cache].read())
+                                break;
                         }
-                    }
-
-                    // if data and instruction have the inval line, need two responses  
-                    if ( r_tgt_icache_rsp and r_tgt_dcache_rsp )
-                    {
-                        if ( p_vci_tgt.rspack.read() )
+
+                        tgt_icache_rsp = (tgt_icache_rsp_num_cache<m_nb_icache);
+#endif
+
+                        PRINTF("      * <TGT> icache_rsp [%d] : %d\n",tgt_icache_rsp_num_cache,(uint32_t) tgt_icache_rsp);
+                        PRINTF("      * <TGT> dcache_rsp [%d] : %d\n",(uint32_t)r_tgt_num_cache,(uint32_t) r_tgt_dcache_rsp[r_tgt_num_cache]);
+
+                        if (tgt_icache_rsp or r_tgt_dcache_rsp[r_tgt_num_cache])
                         {
-                            r_tgt_icache_rsp = false; // only reset one for respond the second time 
+                            // Have send one response
+                            if ( p_vci_tgt.rspack.read())
+                            {
+                                // reset dcache if activated
+                                if (r_tgt_dcache_rsp[r_tgt_num_cache])
+                                    r_tgt_dcache_rsp[r_tgt_num_cache] = false;
+                                else
+                                    // reset one icache
+                                    r_tgt_icache_rsp[tgt_icache_rsp_num_cache] = false;
+                            }
                         }
-                    }
-
-                    // if there is no need for a response
-                    if ( not r_tgt_icache_rsp and not r_tgt_dcache_rsp )
+
+                        // // one response
+                        // if ( not r_tgt_icache_rsp[r_tgt_num_cache] or not r_tgt_dcache_rsp[r_tgt_num_cache] )
+                        // {
+                        //     if ( p_vci_tgt.rspack.read() )
+                        //     {
+                        //         r_vci_tgt_fsm = TGT_IDLE; 
+                        //         r_tgt_icache_rsp[r_tgt_num_cache] = false;
+                        //         r_tgt_dcache_rsp[r_tgt_num_cache] = false;
+                        //     }
+                        // }
+                        
+                        // // if data and instruction have the inval line, need two responses  
+                        // if ( r_tgt_icache_rsp[r_tgt_num_cache] and r_tgt_dcache_rsp[r_tgt_num_cache] )
+                        // {
+                        //     if ( p_vci_tgt.rspack.read() )
+                        //     {
+                        //         r_tgt_icache_rsp[r_tgt_num_cache] = false; // only reset one for respond the second time 
+                        //     }
+                        // }
+
+                        PRINTF("      * <TGT> icache_rsp    : %d\n",(uint32_t) r_tgt_icache_rsp);
+                        PRINTF("      * <TGT> dcache_rsp[%d] : %d\n",(uint32_t)r_tgt_num_cache,(uint32_t)r_tgt_dcache_rsp[r_tgt_num_cache].read());
+                        // if there is no need for a response
+                        if (not tgt_icache_rsp and not r_tgt_dcache_rsp[r_tgt_num_cache] )
+                        {
+                            r_vci_tgt_fsm = TGT_IDLE;
+                        }
+                        
+                    }
+                    break;
+                }
+                ////////////////////
+            case TGT_RSP_ICACHE:
+                {
+                    bool transaction_rsp = (p_vci_tgt.rspack.read() or not r_tgt_icache_rsp[r_tgt_num_cache].read()) and not r_tgt_icache_req[r_tgt_num_cache].read();
+
+                    PRINTF("      * <TGT> RSP_ICACHE : transaction : %d ((%d or not %d) and not %d)\n",transaction_rsp
+                           ,(int)p_vci_tgt.rspack.read()
+                           ,(int)r_tgt_icache_rsp[r_tgt_num_cache].read()
+                           ,(int)r_tgt_icache_req[r_tgt_num_cache].read()
+                           );
+
+                    if (transaction_rsp) 
                     {
                         r_vci_tgt_fsm = TGT_IDLE;
-                    }
-
-                }
-                break;
-                ////////////////////
-            case TGT_RSP_ICACHE:
-                {
-                    if ( (p_vci_tgt.rspack.read() or not r_tgt_icache_rsp.read()) and not r_tgt_icache_req.read() ) 
+                        r_tgt_icache_rsp[r_tgt_num_cache] = false; 
+                    }
+                    break;
+                }
+
+            case TGT_RSP_DCACHE:
+                {
+                    bool transaction_rsp = (p_vci_tgt.rspack.read() or not r_tgt_dcache_rsp[r_tgt_num_cache].read()) and not r_tgt_dcache_req[r_tgt_num_cache].read();
+
+                    PRINTF("      * <TGT> RSP_DCACHE : transaction : %d\n",transaction_rsp);
+
+                    if (transaction_rsp) 
                     {
                         r_vci_tgt_fsm = TGT_IDLE;
-                        r_tgt_icache_rsp = false; 
+                        r_tgt_dcache_rsp[r_tgt_num_cache] = false; 
                     }
                     break;
                 }
-
-            case TGT_RSP_DCACHE:
-                {
-                    if ( (p_vci_tgt.rspack.read() or not r_tgt_dcache_rsp.read()) and not r_tgt_dcache_req.read() ) 
-                    {
-                        r_vci_tgt_fsm = TGT_IDLE;
-                        r_tgt_dcache_rsp = false; 
-                    }
-                    break;
-                }
         } // end switch TGT_FSM
+
+        /////////////////////////////////////////////////////////////////////
+        // Interface between CPU and CACHE FSM
+        ///////////////////////////////////////////////////////////////////////
+
+        uint32_t ireq_num_cache [m_nb_cpu];
+        uint32_t dreq_num_cache [m_nb_cpu];
+        bool     have_sync = false;
+
+        {
+            typename iss_t::InstructionRequest _ireq = ISS_IREQ_INITIALIZER;
+            typename iss_t::DataRequest        _dreq = ISS_DREQ_INITIALIZER;
+
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            {
+                ireq [num_cache] = _ireq;
+              //irsp [num_cache] = _irsp;
+            }
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            {
+                dreq [num_cache] = _dreq;
+              //drsp [num_cache] = _drsp;
+                
+                have_sync |= r_dcache_sync [num_cache];
+            }
+        }
+
+        for (uint32_t _num_cpu=0; _num_cpu<m_nb_cpu; ++_num_cpu)
+        {
+            // round robin priority
+            uint32_t num_cpu = (r_cpu_prior+_num_cpu)%m_nb_cpu;
+
+            typename iss_t::InstructionRequest _ireq = ISS_IREQ_INITIALIZER;
+            typename iss_t::DataRequest        _dreq = ISS_DREQ_INITIALIZER;
+            
+            m_iss[num_cpu]->getRequests(_ireq, _dreq);
+
+            addr_40  addr;
+            uint32_t num_cache;
+
+            addr      = (addr_40)_ireq.addr;
+            num_cache = get_num_icache(addr,num_cpu);
+
+            // test if already used
+            if (not ireq[num_cache].valid and
+                (r_icache_lock [num_cache] == m_nb_cpu) or
+                (r_icache_lock [num_cache] == num_cpu))
+            {
+                bool valid = _ireq.valid;
+
+                if (valid)
+                {
+                    PRINTF("    * <CPU2CACHE> ICACHE :    Transaction between cpu %d and cache %d (lock)\n",num_cpu,num_cache);
+                    ireq_num_cache [num_cpu  ] = num_cache;
+                    r_icache_lock [num_cache] = num_cpu;
+                }
+                else
+                {
+                    PRINTF("    * <CPU2CACHE> ICACHE : No Transaction between cpu %d and cache %d : invalid\n",num_cpu,num_cache);
+                    ireq_num_cache [num_cpu] = m_nb_icache;
+                }
+
+                ireq_cached    [num_cache] = m_cacheability_table[(vci_addr_t)_ireq.addr];
+                ireq_num_cpu   [num_cache] = num_cpu;
+                ireq           [num_cache] = _ireq;
+                ireq           [num_cache].addr = addr;
+            }
+            else
+            {
+                PRINTF("    * <CPU2CACHE> ICACHE : No transaction (cpu %d)\n",num_cpu);
+
+                ireq_num_cache [num_cpu] = m_nb_icache;
+            }
+
+            addr      = (addr_40)_dreq.addr;
+            num_cache = get_num_dcache(addr);
+
+            // test if already used
+            if (not dreq[num_cache].valid and
+                not have_sync and
+                (r_dcache_lock [num_cache] == m_nb_cpu) or
+                (r_dcache_lock [num_cache] == num_cpu))
+            {
+                bool valid = _dreq.valid;
+
+                if (valid)
+                {
+                    PRINTF("    * <CPU2CACHE> DCACHE :    Transaction between cpu %d and cache %d (lock)\n",num_cpu,num_cache);
+                    dreq_num_cache [num_cpu  ] = num_cache;
+                    r_dcache_lock [num_cache] = num_cpu;
+                }
+                else
+                {
+                    PRINTF("    * <CPU2CACHE> DCACHE : No Transaction between cpu %d and cache %d : invalid\n",num_cpu,num_cache);
+                    dreq_num_cache [num_cpu] = m_nb_dcache;
+                }
+
+                dreq_cached    [num_cache] = m_cacheability_table[(vci_addr_t)_dreq.addr];
+                dreq_num_cpu   [num_cache] = num_cpu;
+                dreq           [num_cache] = _dreq;
+                dreq           [num_cache].addr = addr;
+            }
+            else
+            {
+                PRINTF("    * <CPU2CACHE> DCACHE : No transaction (cpu %d)\n",num_cpu);
+
+                dreq_num_cache [num_cpu] = m_nb_dcache;
+            }
+
+
+#if CC_XCACHE_WRAPPER_DEBUG
+        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
+        {
+            std::cout << "    * <CPU2CACHE> Instruction Request   : " << ireq_num_cache[num_cpu] << " - " << _ireq << std::endl
+                      << "    * <CPU2CACHE> Data        Request   : " << dreq_num_cache[num_cpu] << " - " << _dreq << std::endl;
+        }
+#endif
+        }
+
+        // round robin priority
+        r_cpu_prior = (r_cpu_prior+1)%m_nb_cpu;
 
         /////////////////////////////////////////////////////////////////////
@@ -899,75 +1759,85 @@
         //    flip-flop. It is reset by the ICACHE FSM.
         ///////////////////////////////////////////////////////////////////////
-
-        typename iss_t::InstructionRequest  ireq = ISS_IREQ_INITIALIZER;
-        typename iss_t::InstructionResponse irsp = ISS_IRSP_INITIALIZER;
-
-        typename iss_t::DataRequest         dreq = ISS_DREQ_INITIALIZER;
-        typename iss_t::DataResponse        drsp = ISS_DRSP_INITIALIZER;
-
-        m_iss.getRequests( ireq, dreq );
-
-#if CC_XCACHE_WRAPPER_DEBUG
-        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
-            std::cout << "    * Instruction Request  : " << ireq << std::endl;
-#endif
-
-        switch(r_icache_fsm) {
+        
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        {
+            typename iss_t::InstructionRequest  _ireq = ireq [num_cache];
+            typename iss_t::InstructionResponse _irsp = ISS_IRSP_INITIALIZER;
+
+        switch(r_icache_fsm[num_cache]) {
             /////////////////
             case ICACHE_IDLE:
                 {
-                    if ( r_tgt_icache_req ) {   // external request
-                        if ( ireq.valid ) m_cost_ins_miss_frz++;
-                        r_icache_fsm = ICACHE_CC_CHECK;
-                        r_icache_fsm_save = r_icache_fsm.read();
+                    if ( r_tgt_icache_req[num_cache] ) {   // external request
+                        // if ( _ireq.valid ) m_cost_ins_miss_frz++;
+                        r_icache_fsm     [num_cache] = ICACHE_CC_CHECK;
+                        r_icache_fsm_save[num_cache] = r_icache_fsm[num_cache];
                         break;
                     } 
-                    if ( ireq.valid ) {
-                        data_t  icache_ins = 0;
-                        bool    icache_hit = false;
-                        bool    icache_cached = m_cacheability_table[(vci_addr_t)ireq.addr];
-                        bool    icache_cleanup_hit = r_icache_cleanup_req and (((addr_40)ireq.addr >> (addr_40)m_icache_words_shift) == r_icache_cleanup_line.read());
+                    if ( _ireq.valid ) {
+                        data_t   icache_ins         = 0;
+                        bool     icache_hit         = false;
+                        bool     icache_cached      = ireq_cached  [num_cache];
+                        // uint32_t icache_num_cpu     = ireq_num_cpu [num_cache];
+                        bool     icache_cleanup_hit = r_icache_cleanup_req[num_cache] and (((addr_40)_ireq.addr >> (addr_40)m_icache_words_shift) == r_icache_cleanup_line[num_cache].read());
 
                         // icache_hit & icache_ins evaluation
                         if ( icache_cached ) {
-                            icache_hit = r_icache.read((vci_addr_t) ireq.addr, &icache_ins);
+                            icache_hit = r_icache[num_cache]->read((vci_addr_t) _ireq.addr, &icache_ins);
                         } else {
                             // if uncache, again in the icache_miss_buf
-                            icache_hit = ( r_icache_buf_unc_valid and ((addr_40) ireq.addr == (addr_40)r_icache_addr_save));
-                            icache_ins = CACHE_MISS_BUF_RSP_DATA(i,0);
-                            CACHE_MISS_BUF_RSP_POP(i);
+                            icache_hit = (r_icache_buf_unc_valid[num_cache] and ((addr_40) _ireq.addr == (addr_40)r_icache_addr_save[num_cache]));
+                            icache_ins = CACHE_MISS_BUF_RSP_DATA(i,num_cache,0);
+
+                            if (icache_hit)
+                                CACHE_MISS_BUF_RSP_POP(i,num_cache);
                         }
 
-                        PRINTF("    * <ICACHE> hit %d - cached %d - cleanup_hit %d\n",icache_hit, icache_cached, icache_cleanup_hit);
-
-                        ASSERT( not (icache_hit and icache_cleanup_hit),
-                                "Icache hit and icache_cleanup_hit");
-
-                        if ( not icache_hit and not icache_cleanup_hit) {
-                            m_cpt_ins_miss++;
-                            m_cost_ins_miss_frz++;
-                            r_icache_addr_save = (addr_40) ireq.addr;
-
-                            CACHE_MISS_BUF_REQ_INIT(i);
-
-                            if ( icache_cached ) {
+                        PRINTF("    * <ICACHE [%d]> hit %d - cached %d - cleanup_hit %d\n",num_cache, icache_hit, icache_cached, icache_cleanup_hit);
+
+                        // ASSERT( not (icache_hit and icache_cleanup_hit),
+                        //         "Icache hit and icache_cleanup_hit");
+
+                        if (icache_hit and icache_cleanup_hit)
+                        {
+                            PRINTF("    * <ICACHE [%d]> Warning : icache hit and icache_cleanup_hit\n",num_cache);
+                            icache_hit = false;
+                        }
+                        else
+                        {
+                            if ( not icache_hit and not icache_cleanup_hit) 
+                            {
+                                m_cpt_ins_miss++;
+                                m_cost_ins_miss_frz++;
+                                r_icache_addr_save[num_cache] = (addr_40) _ireq.addr;
+                                
+                                CACHE_MISS_BUF_REQ_INIT(i,num_cache);
+                                
+                                if ( icache_cached )
+                                {
 #if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                                r_icache_fsm = ICACHE_MISS_VICTIM;
+                                    r_icache_fsm     [num_cache] = ICACHE_MISS_VICTIM;
 #else
-                                r_icache_fsm = ICACHE_MISS_WAIT;
-#endif
-                                r_icache_miss_req = true;
-                               
-                            } else {
-                                r_icache_fsm = ICACHE_UNC_WAIT;
-                                r_icache_unc_req = true;
+                                    r_icache_fsm     [num_cache] = ICACHE_MISS_WAIT;
+#endif
+                                    r_icache_miss_req[num_cache] = true;
+                                    
+                                }
+                                else
+                                {
+                                    r_icache_fsm    [num_cache] = ICACHE_UNC_WAIT;
+                                    r_icache_unc_req[num_cache] = true;
+                                }
                             }
-                        } else {
-                            r_icache_buf_unc_valid = false;
+                            else
+                            {
+                                r_icache_buf_unc_valid[num_cache] = false;
+                            }
+                            m_cpt_icache_dir_read += m_icache_ways;
+                            m_cpt_icache_data_read += m_icache_ways;
                         }
-                        m_cpt_icache_dir_read += m_icache_ways;
-                        m_cpt_icache_data_read += m_icache_ways;
-                        irsp.valid          = icache_hit;
-                        irsp.instruction    = icache_ins;
+
+                        _irsp.valid          = icache_hit;
+                        _irsp.instruction    = icache_ins;
                     }
                     break;
@@ -977,17 +1847,17 @@
             case ICACHE_MISS_VICTIM:
                 {
-                    if (not r_icache_cleanup_req)
+                    if (not r_icache_cleanup_req[num_cache])
                     {
                         size_t     way;
                         size_t     set;
-                        vci_addr_t addr = (vci_addr_t) r_icache_addr_save.read();
+                        vci_addr_t addr = (vci_addr_t) r_icache_addr_save[num_cache].read();
                         vci_addr_t victim;
                         
-                        r_icache_cleanup_req  = r_icache.victim_select(addr, &victim, &way, &set );
-                        r_icache_cleanup_line = (addr_40) victim;
-                        r_icache_miss_way     = way;
-                        r_icache_miss_set     = set;
+                        r_icache_cleanup_req [num_cache] = r_icache[num_cache]->victim_select(addr, &victim, &way, &set );
+                        r_icache_cleanup_line[num_cache] = (addr_40) victim;
+                        r_icache_miss_way    [num_cache] = way;
+                        r_icache_miss_set    [num_cache] = set;
                         
-                        r_icache_fsm = ICACHE_MISS_WAIT;
+                        r_icache_fsm         [num_cache] = ICACHE_MISS_WAIT;
                     }
                     break;
